      subroutine dif2
     & (thetv, thets, 
     & gg1s, gg1v, ul1, rrl1, ttl1, ellmy1, ellsi1, thm1,
     & gg2s, gg2v, ul2, rrl2, ttl2, ellmy2, ellsi2, thm2,
     & skyl, rsl, thss, bdplants, bdsoil)
c     A. Kuusk 19.01.2000
c     Soil contribution to diffuse fluxes fixed 22.07.2009,
c     thanks to Abdelaziz Kallel!
c
c
      implicit double precision (a-h, o-z)
      include 'nch.h'
c
      data phi/0.d0/
c   Diffuse reflection and transmission of a 2-layer medium
c   The lower layer is layer 1, and the upper layer is layer 2.
c
      call soil
     & (rsl, thetv, thets, thss, phi,
     & rsosoil, rsdsoil, rodsoil, rddsoil)
c                            ! scattering operators, the lower layer
      if (ul1 .le. 0d0) then
         rdd1  = 0.d0
         rdo1  = 0.d0
         rsd1  = 0.d0
         rso1  = 0.d0
         tdd1  = 1.d0
         tdo1  = 0.d0
         tsd1  = 0.d0
      else
         ggj1 = (1.289d0*ellmy1 - 1.816d0*ellsi1)*
     &            ((cos(thm1))**2  - .33333333333d0) + .31823d0
         call layer
     & (thets, thetv, gg1s, gg1v, ggj1, ul1, rrl1, ttl1, 
     & rdd1, tdd1, rdo1, tdo1, rsd1, tsd1, rso1)
      endif
c                            ! scattering operators, the upper layer
      if (ul2 .le. 0d0) then
         rdd2  = 0.d0
         rdo2  = 0.d0
         rsd2  = 0.d0
         rso2  = 0.d0
         tdd2  = 1.d0
         tdo2  = 0.d0
         tsd2  = 0.d0
      else
         ggj2 = (1.289d0*ellmy2 - 1.816d0*ellsi2)*
     &           ((cos(thm2))**2  - .33333333333d0) + .31823d0
         call layer
     & (thets, thetv, gg2s, gg2v, ggj2, ul2, rrl2, ttl2, 
     & rdd2, tdd2, rdo2, tdo2, rsd2, tsd2, rso2)
      endif
c                                        ! Adding method, two canopy layers
      sq   = 1.d0 - skyl
      ts11 = exp(-ul1*gg1s/cos(thets))
      ts12 = exp(-ul1*gg1v/cos(thetv))
      ts21 = exp(-ul2*gg2s/cos(thets))
      ts22 = exp(-ul2*gg2v/cos(thetv))
      ts1  = ts11*ts21
      ts2  = ts12*ts22
c
      fac  = 1.d0/(1.d0 - rdd1*rdd2)
      rdd  = rdd2 + tdd2*rdd1*tdd2*fac
      rso  = rso2 + ts21*rso1*ts22
     &       + (ts21*rsd1*tdo2
     &       + tsd2*rdd1*tdo2
     &       + tsd2*rdo1*ts22
     &       )*fac
      rdo  = rdo2 + (tdd2*rdo1*ts22 + tdd2*rdd1*tdo2)*fac
      tdd  = tdd1*tdd2*fac
      tsd  = (tsd1*ts21 + tsd2*tdd1)*fac
      tdo  = (tdd1*tdo2 + tdo1*ts22)*fac
c                                         ! Adding method, canopy + soil
      fac  = 1.d0/(1.d0 - rdd*rddsoil)
      bcs  = sq*(rso
     &           + (ts1*rsdsoil + tsd*rddsoil)*fac*tdo)
      bcd  = skyl*(rdo + tdd*rddsoil*tdo*fac)
      bdplants = bcs + bcd
c
      bdsoil   = ((sq*tsd + skyl*tdd)*rodsoil +
     &           sq*ts1*rsdsoil*rdd*rodsoil)*ts2*fac
c
      return
      end
*
**********************************************************************
*
