      function func
     & (nxx, xxf)
c
c  functl(..,..) - the merit function for the inversion of ACRM,
c  it serves as an interface in direct problem. A. Kuusk  4.12.2002
c
c  Two-layer model and two leaf optics models (PROSPECT and LIBERTY)
c  February 2002.
c
c  Expert estimate in the model inversion May 2001.
c
      include 'acrmpar.h'
      include 'nch.h'
      include 'ifunc.h'
      include 'spec.h'
      include 'spec3.h'
c
      save at, xe, xx, xa, xb, xdelt, llxx
      save bqjarr, drhoarr, nref
      save 
     &  thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bang, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  penalty, bc1, bs1, bdplants, bdsoil, ggv
c
      character*10 lmod1, lmod2
c
      dimension 
     & ccomp1(ncomp0), ccomp2(ncomp0)
c
      dimension bqjarr(nreflval), drhoarr(nreflval)
c
      dimension thknot(nangls), p14(nknots)
c
      dimension llxx(nvar), xe(nvar), xx(nvar), xa(nvar), xb(nvar), 
     &          xdelt(nvar), xxf(nvar)
c
      common /par/ zeps, tol, tiny, alphopt, betopt, gammopt, 
     & ier, ncount, nfmax, itmax, itbr, nbrak, ilo
c
      ncount = ncount + 1
c
      skyl  = 0.d0
      ijob  = i_job 
      thets = t_hs
      thetv = t_hv
      phi   = p_hi
      bang  = b_ang
      rlambda = r_lmbda
c
      if (ncount .eq. 1) then
         at      = a_t
         dcell0  = d_cel0
         pkhair  = p_khair
         thss    = t_hss
         lmod2  = l_mod2
         ncomp2 = n_cmp2
         lmod1  = l_mod1
         ncomp1 = n_cmp1
c
         do jx = 1, nvar
            llxx(jx)  = l_lxx(jx)
            xe(jx)    = x_e(jx)
            xx(jx)    = x_x(jx)
            xa(jx)    = x_a(jx)
            xb(jx)    = x_b(jx)
            xdelt(jx) = x_delt(jx)
         enddo
c
         if (ijob .gt. 3) then
            nref = n_ref
            do jr = 1, nref
               bqjarr(jr)  = b_qjarr(jr)
               drhoarr(jr) = d_rhoarr(jr)
            enddo
         endif
c
         do ja = 1, nknots
            p14(ja) = p_14(ja)
            thknot(ja) = t_hknot(ja)
         enddo
      endif
c
      f   = 0.d0
c                                ! check constraints and scale variables
      if (ijob .gt. 3) then
         do i = 1, nxx
            li  = llxx(i)
            xi3 = xxf(i)
            x2  = 0.d0
            if (xi3 .lt. -5.d0) then
               x2  = xi3 + 5.d0
               xi3 =  -5.d0
            else if (xi3 .gt. 5.d0) then
               x2  = xi3 - 5.d0
               xi3 = 5.d0
            endif
            xli    = xi3/xb(li) + xa(li)
            xx(li) = xli
            f      = f + x2**2*at
            if (ijob .eq. 4) f  = f + ((xli - xe(li))/xdelt(li))**2
         enddo
      endif
c                                   ! initialization of model parameters
c
c    LAI is corrected for clumping
      clmp2 = xx(31)
      ul2   = xx(29)*clmp2
      sl2   = xx(30)
      if (sl2 .le. 0.d0) sl2 = .01d0
      szz   = xx(32)
      eln2  = xx(33)
      ee2   = 1.d0 - exp(-eln2)
      thm2  = xx(34)*dr
      rnc2  = xx(35)
      slw2  = xx(36)
      scomp2 = -xx(37)
      do jc = 1, ncomp2
         ccomp2(jc) = xx(jc+36)
         scomp2 = scomp2 + ccomp2(jc)
      enddo
      if (lmod2 .eq. 'liberty') then
            dcell2 = xx(47)
            asp2   = xx(48)
      endif
c  The PROSPECT leaf structure parameter is corrected for clumping
      vai2  = xx(49)/clmp2
      clmp1 = xx(52)
      ul1   = xx(50)*clmp1
      sl1   = xx(51)
      if (sl1 .le. 0.d0) sl1 = .01d0
      eln1  = xx(53)
      ee1   = 1.d0 - exp(-eln1)
      thm1  = xx(54)*dr
      rnc1  = xx(55)
      slw1  = xx(56)
      scomp1 = -xx(57)
      do jc = 1, ncomp1
         ccomp1(jc) = xx(jc+56)
         scomp1 = scomp1 + ccomp1(jc)
      enddo
      if (lmod1 .eq. 'liberty') then
            dcell1 = xx(67)
            asp1   = xx(68)
      endif
      vai1  = xx(69)/clmp1
      rsl1  = xx(70)
      rsl2  = xx(71)
      rsl3  = xx(72)
      rsl4  = xx(73)
c
      if (ijob .le. 3) then
         call smcrm
     &  (thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bang, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  ggv, penalty, gfr2v, bc1, bs1, bdplants, bdsoil)
*    &  ggv, penalty, bc1, bs1, bdplants, bdsoil)
            b_c1  = bc1
            b_s1  = bs1
            b_dplants = bdplants
            b_dsoil   = bdsoil
            s_q   = 1.d0 - skyl
            g_gv  = ggv
            g_fr2v = gfr2v
            r_efl1 = refl1
            t_ran1 = tran1
            r_efl2 = refl2
            t_ran2 = tran2
      else
         do jr = 1, nref
            thetv   = t_h1j(jr)
            bang    = b_aj(jr)
            thets   = t_h2j(jr)
            phi     = p_hij(jr)
            rlambda = w_lgth(jr)
            call smcrm
     &  (thknot, p14, 
     &  lmod2, ncomp2, ul2, sl2, szz, eln2, thm2, 
     &  slw2, rnc2, vai2, dcell2, asp2, ccomp2, 
     &  lmod1, ncomp1, ul1, sl1, eln1, thm1, 
     &  slw1, rnc1, vai1, dcell1, asp1, ccomp1, 
     &  thets, bang, pkhair, dcell0, rsl1, rsl2, rsl3, rsl4, thss,
     &  thetv, phi, rlambda, skyl, ee1, rn1, refl1, tran1, 
     &  ee2, rn2, refl2, tran2, rsl,
     &  ggv, penalty, gfr2v, bc1, bs1, bdplants, bdsoil)
*    &  ggv, penalty, bc1, bs1, bdplants, bdsoil)
            bq = (1.d0 - skyl)*(bc1 + bs1) + bdplants + bdsoil
            b_simul(jr) = bq
c
c                                   ! calculation of the merit function
            xi4  = bqjarr(jr) - bq
            if (ijob .eq. 5) then
               f    = f + xi4**2
            else
               if(drhoarr(jr) .le. 0.d0) drhoarr(jr) = 0.1d0*bqjarr(jr)
               f    = f + (xi4/drhoarr(jr))**2
            endif
         enddo
*        f = f + at*(scomp1 - 100.d0)**2 + at*(scomp2 - 100.d0)**2
      endif
c
      func  = f
c
*           print *, 'f  = ', f
      return
      end
*
************************************************************************
*
