      subroutine gauleg(x1, x2, x, w, n)
c   Gauss-Legendre n-point quadrature. Press et al., 1992, Chpt. 4.5
c
      include 'acrmpar.h'
      include 'nch.h'
c
*     implicit double precision (a-h, o-z)
*     dimension x(48), w(48)
      dimension x(ncub), w(ncub)
      parameter (eps = .1d-14)
c
*     pi = acos(-1.d0)
      m  = (n + 1)/2
      xm = 0.5d0*(x2 + x1)
      xl = 0.5d0*(x2 - x1)
      do 12 i = 1, m
        z = cos(pi*(dble(i) - .25d0)/(dble(n) + .5d0))
1       continue
          p1 = 1.d0
          p2 = 0.d0
          do 11 j = 1, n
            p3 = p2
            p2 = p1
            p1 = ((2.d0*dble(j) - 1.d0)*z*p2 - 
     &           (dble(j) - 1.d0)*p3)/dble(j)
11        continue
          pp = dble(n)*(z*p1 - p2)/(z*z - 1.d0)
          z1 = z
          z  = z1 - p1/pp
        if(abs(z - z1) .gt. eps) goto 1
        if (abs(z) .lt. eps) z = 0.d0
        x(i)     = xm - xl*z
        x(n+1-i) = xm + xl*z
        w(i)     = 2.d0*xl/((1.d0 - z*z)*pp*pp)
        w(n+1-i) = w(i)
12    continue
      return
      end

