      subroutine liberty
     & (thknot, p14, rnnl, coeff, vai, asp, rinf, refl, tran)
c
c A Leaf Incorporating Biochemistry Exhibiting Reflectance
c and Transmittance Yields
c
c
c Written by: Terence Dawson
c Department of Geography
c University of Southampton
c Highfield
c Southampton, UK
c
c Fortran  version by Andres Kuusk, Tartu Observatory, Estonia
c                     andres@aai.ee
c
*     implicit double precision (a-h, o-z)
      include 'acrmpar.h'
      include 'nch.h'
c
      dimension thknot(nangls), p14(nknots)
      data rnn0/1.d0/
c
      sme = 0.d0
      do i1 = 2, nknots
         alpha = thknot(i1)
         calp  = cos(alpha)
         salp  = sin(alpha)
         call fresnel(rnnl, calp, rfr)
         sme  = sme + rfr*salp*p14(i1)
      enddo
      sme = sme*2.d0
c
      sacrit  = rnn0/rnnl
      acritic = asin(sacrit)
      icritic = int(acritic/dr)
      smint   = 0.d0
      do ja = 1, icritic
         alpha = dble(ja)*dr
         calp  = cos(alpha)
         salp  = sin(alpha)
         call fresnel(rnnl, calp, rfr)
         smint = smint + rfr*salp*calp
      enddo
      smint = smint*dr
      smi   = 1.d0 - sacrit**2 + 2.d0*smint
c
      rmm = 2.d0/coeff**2*(1.d0 - (coeff + 1.d0)*exp(-coeff))
      rtt = (1.d0 - smi)*rmm/(1.d0 - smi*rmm)
      rxx = asp/(1.d0 - (1.d0 - 2.d0*asp)*rtt)
c
c                            **********  calc_R
      aaa = sme*rtt + rxx*rtt - sme - rtt - rxx*sme*rtt
      bbb = 1.d0 + rxx*sme*rtt - 2.d0*rtt*(rxx*sme)**2
      ccc = 2.d0*sme*rxx**2*rtt - rxx*rtt - 2.d0*rxx*sme
c
      diskr = bbb**2 - 4.d0*aaa*ccc
      if (diskr .ge. 0.d0) then
         rrr = (sqrt(diskr) - bbb)/(2.d0*aaa)
         if ((rrr .lt. 0.d0) .or. (rrr .gt. 1.d0)) then
            rrr = (-sqrt(diskr) - bbb)/(2.d0*aaa)
         endif
       else
         rinf = -99.d0
         refl = rinf
         tran = rinf
         return
       endif
c
      aaa = 2.d0*rxx*sme + rxx*rtt - 2.d0*rtt*sme*rxx**2
      rb  = aaa
      tb  = sqrt((rrr - rb)*(1.d0 - rrr*rb)/rrr)
c
c                           ******** cont_func
      frac = vai - int(vai)
      yyy  = (1.d0 + tb)**2 - tb**2
      top  = tb**(1.d0 + frac)*yyy**(1.d0 - frac)
      bot1 = (1.d0 + tb)**(2.d0*(1.d0 - frac)) - rb**2
      bot2 = 1.d0 + 64.d0/3.d0*frac*(frac - .5d0)*(frac - 1.d0)*.001d0
      tinf = top/bot1/bot2
      rinf = (1.d0 + rb**2 - tb**2 - sqrt((1.d0 + rb**2 - tb**2)**2 -
     & 4.d0*rb**2*(1.d0 - tinf**2)))/rb*.5d0
c
      curt = 1.d0
      curr = 0.d0
      if (vai .ge. 2.d0) then
         do js = 1, int(vai - 1.d0)
            prevt = curt
            prevr = curr
            curt = prevt*tb/(1.d0 - prevr*rb)
            curr = prevr + prevt**2*rb/(1.d0 - prevr*rb)
         enddo
      endif
c
      tran  = curt*tinf/(1.d0 - rinf*curr)
      refl  = curr + curt**2*rinf/(1.d0 - rinf*curr)
      return
      end
*
**********************************************************************
*
      subroutine fresnel(rnnl, calp, rfr)
c                                Fresnel' reflection coefficient
c                                A. Kuusk 02.01.1991
c  The new version               A. Kuusk 09.11.2000 andres@aai.ee
c  input parameters are calp = cos(th_incident),  rn = refract_ind.
c
      implicit double precision (a-h, o-z)
c
      sa2 = 1.d0 - calp**2
      aag = sqrt(rnnl**2 - sa2)
      rfr = (((aag - calp)/(aag + calp))**2 +
     &       ((rnnl**2*calp - aag)/(rnnl**2*calp + aag))**2)/2.d0
      return
      end
*
**********************************************************************
*
