c ::::::::::::::
c minsub.F
c ::::::::::::::
      subroutine amoeba(pam, ya, ndim, ftol, funk, iter)
c  Downhill simplex method of Nelder and Mead in multidimensions
c  Numerical Recipes,  Cambridge University Press,  1986,  Program 10.4
c
c
      implicit double precision (a-h, o-z)
      include 'invpar.h'
c
      external funk
      dimension pam(nvar+1, nvar)
      dimension ya(nvar), pr(nvar), prr(nvar), pbar(nvar)
c
      mpts = ndim + 1
      iter = 0
1     ilo  = 1
c
      if (ya(1) .gt. ya(2)) then
        ihi  = 1
        inhi = 2
      else
        ihi  = 2
        inhi = 1
      endif
c
      do 11 i = 1, mpts
         if (ya(i) .lt. ya(ilo)) ilo = i
         if (ya(i) .gt. ya(ihi)) then
            inhi = ihi
            ihi  = i
         else if (ya(i) .gt. ya(inhi)) then
            if (i .ne. ihi) inhi = i
         endif
11    continue
c
      rtol = 2.d0*abs(ya(ihi) - ya(ilo))/(abs(ya(ihi)) + abs(ya(ilo)))
      if (rtol .lt. ftol) then
         ier = 1
         goto 99
      endif
      if (iter .ge. itmax) then
         ier = 3
         goto 99
      else if (ncount .ge. nfmax) then
         ier = 2
         goto 99
      endif
      iter = iter + 1
c
      do 12 j = 1, ndim
         pbar(j) = 0.d0
12    continue
      do 14 i = 1, mpts
         if (i .ne. ihi) then
            do 13 j = 1, ndim
               pbar(j) = pbar(j) + pam(i, j)
13          continue
         endif
14    continue
c
      do 15 j = 1, ndim
         pbar(j) = pbar(j)/ndim
         pr(j)   = (1.d0 + alphopt)*pbar(j) - alphopt*pam(ihi, j)
15    continue
      ypr = funk(ndim, pr)
c
      if (ypr .le. ya(ilo)) then
         do 16 j = 1, ndim
            prr(j) = gammopt*pr(j) + (1.d0 - gammopt)*pbar(j)
16       continue
         yprr = funk(ndim, prr)
         if (yprr .lt. ya(ilo)) then
            do 17 j = 1, ndim
               pam(ihi, j) = prr(j)
17          continue
            ya(ihi) = yprr
         else
            do 18 j = 1, ndim
               pam(ihi, j) = pr(j)
18          continue
            ya(ihi) = ypr
         endif
      else if (ypr .ge. ya(inhi)) then
         if (ypr .lt. ya(ihi)) then
            do 19 j = 1, ndim
               pam(ihi, j) = pr(j)
19          continue
            ya(ihi) = ypr
         endif
         do 21 j = 1, ndim
            prr(j) = betopt*pam(ihi, j) + (1.d0 - betopt)*pbar(j)
21       continue
         yprr = funk(ndim, prr)
         if (yprr .lt. ya(ihi)) then
            do 22 j = 1, ndim
               pam(ihi, j) = prr(j)
22          continue
            ya(ihi) = yprr
         else
            do 24 i = 1, mpts
               if (i .ne. ilo) then
                  do 23 j = 1, ndim
                      pr(j)   = .5d0*(pam(i, j) + pam(ilo, j))
                      pam(i, j) = pr(j)
23                continue
                  ya(i) = funk(ndim, pr)
               endif
24          continue
         endif
      else
         do 25 j = 1, ndim
            pam(ihi, j) = pr(j)
25       continue
         ya(ihi) = ypr
      endif
c
      goto 1
99    return
      end
*
******************************************************************
*
      subroutine powell(ppow, xi,  nxx, ftol, fret, iter)
c  Powell's method in multidimensions
c  Numerical Recipes,  Cambridge University Press,  1986,  Program 10.5
c
c
      implicit double precision (a-h, o-z)
      include 'invpar.h'
c
      dimension ppow(nvar), xi(nvar+1, nvar), pt(nvar), ptt(nvar),
     & xit(nvar)
*            print *, 'powell'
c
      fret = func(nxx, ppow)
c
      do 11 j = 1,  nxx
         pt(j) = ppow(j)
11    continue
      iter = 0
1     iter = iter + 1
      fp   = fret
      ibig = 0
      del  = 0.d0
c
      do 13 i = 1,  nxx
         if (ncount .ge. nfmax) then
            ier = 2
            goto 99
         endif
         do 12 j = 1,  nxx
            xit(j) = xi(j, i)
12       continue
         fptt = fret
c
         call linmin(ppow, xit,  nxx, fret)
c
         if (ier .ne. 0) then
            if (iter. lt. itmax) then
               goto 1
            else
               goto 99
            endif
         endif
         if (abs(fptt - fret) .gt. del) then
            del = abs(fptt - fret)
            ibig = i
         endif
13    continue
c
      if (2.d0*abs(fp - fret) .le. ftol*(abs(fp) + abs(fret))) then
         ier = 1
         goto 99
      endif
      if (iter .gt. itmax) then
         ier = 3
         goto 99
      endif
c
      do 14 j = 1,  nxx
         ptt(j) = 2.d0*ppow(j) - pt(j)
         xit(j) = ppow(j) - pt(j)
         pt(j)  = ppow(j)
14    continue
      fptt = func( nxx, ptt)
      if (fptt .ge. fp) goto 1
      tx = 2.d0*(fp - 2.d0*fret + fptt)*(fp - fret - del)**2 - del*
     &    (fp - fptt)**2
      if (tx .ge. 0.d0) goto 1
      if (ncount .ge. nfmax) then
         ier = 2
         goto 99
      endif
c
      call linmin(ppow, xit,  nxx, fret)
c
      if (ier .ne. 0) then
         if (iter. lt. itmax) then
            goto 1
         else
            goto 99
         endif
      endif
      do 15 j = 1,  nxx
         xi(j, ibig) = xit(j)
15    continue
      goto 1
99    return
      end
*
******************************************************************
*
      subroutine linmin(ppow, xi,  nxx, fret)
c  the internal routine of the subroutine powell(...)
c
c
      implicit double precision (a-h, o-z)
      include 'invpar.h'
c
      external f1dim
      dimension ppow(nvar), xi(nvar), pcom(nvar), xicom(nvar)
      save/f1com/
      common/f1com/ pcom, xicom, ncom
c
      ncom =  nxx
      do 11 j = 1,  nxx
         pcom(j)  = ppow(j)
         xicom(j) = xi(j)
11    continue
      ax  = 0.d0
      xlx = 1.d0
      bx  = 2.d0
c
      call mnbrak(ax, xlx, bx, fa, fx, fb, f1dim)
c
      if (ier .ne. 0) return
c
      fret = brent(ax, xlx, bx, f1dim, xminbr)
c
      do 12 j = 1,  nxx
         xi(j)    = xminbr*xi(j)
         ppow(j)  = ppow(j) + xi(j)
12    continue
      return
      end
c
      function f1dim(xf1)
c
      implicit double precision (a-h, o-z)
      include 'invpar.h'
c
      dimension xt(nvar), pcom(nvar), xicom(nvar)
      save/f1com/
      common/f1com/ pcom, xicom, ncom
c
      do 11 j = 1, ncom
         xt(j) = pcom(j) + xf1*xicom(j)
11    continue
c
      f1dim = func(ncom, xt)
c
      return
      end
*
******************************************************************
*
      subroutine mnbrak(ax, bx, cx, fa, fb, fc, funk)
c  the internal routine of the subroutine powell(...)
c
c
      implicit double precision (a-h, o-z)
      include 'invpar.h'
c
      external funk
      data gold/1.618034d0/, glimit/100.d0/
c
      j = 0
      fa = funk(ax)
      fb = funk(bx)
      if (fb .gt. fa) then
         dum = ax
         ax  = bx
         bx  = dum
         dum = fb
         fb  = fa
         fa  = dum
      endif
      cx = bx + gold*(bx - ax)
c
      fc = funk(cx)
c
1     j = j + 1
      if (j .ge. nbrak) then
         ier = 5
         return
      endif
      if (fb .ge. fc) then
         rmb  = (bx - ax)*(fb - fc)
         qmb  = (bx - cx)*(fb - fa)
         umb  = bx - ((bx - cx)*qmb - (bx - ax)*rmb)/
     &       (2.d0*sign(max(abs(qmb - rmb), tiny), qmb - rmb))
         ulim = bx + glimit*(cx - bx)
         if ((bx - umb)*(umb - cx) .gt. 0.d0) then
            fu = funk(umb)
            if (fu .lt. fc) then
               ax = bx
               fa = fb
               bx = umb
               fb = fu
               return
            else if (fu .gt. fb) then
               cx = umb
               fc = fu
               return
            endif
            umb = cx + gold*(cx - bx)
c
            fu = funk(umb)
c
         else if ((cx - umb)*(umb - ulim) .gt. 0.d0) then
c
            fu = funk(umb)
c
            if (fu .lt. fc) then
               bx = cx
               cx = umb
               umb = cx + gold*(cx - bx)
               fb = fc
               fc = fu
c
               fu = funk(umb)
c
            endif
         else if ((umb - ulim)*(ulim - cx) .ge. 0.d0) then
            umb  = ulim
c
            fu = funk(umb)
c
         else
            umb  = cx + gold*(cx - bx)
c
            fu = funk(umb)
c
         endif
         ax = bx
         bx = cx
         cx = umb
         fa = fb
         fb = fc
         fc = fu
         goto 1
      endif
      return
      end
*
******************************************************************
*
      function brent(ax, bx, cx, fbr, xminbr)
c  the internal routine of the subroutine powell(...)
c
c
      implicit double precision (a-h, o-z)
      include 'invpar.h'
c
      external fbr
      data cgold/.3819660d0/
c
      abr  = min(ax, cx)
      bbr  = max(ax, cx)
      vbr  = bx
      wbr  = vbr
      xbr  = vbr
      ebr  = 0.d0
      dbr  = 0.d0
      fx   = fbr(xbr)
      fv   = fx
      fw   = fx
c
      do 11 iter = 1, itbr
         xm = .5d0*(abr + bbr)
         tol1 = tol*abs(xbr) + zeps
         tol2 = 2.d0*tol1
         if (abs(xbr - xm) .le. (tol2 - .5d0*(bbr - abr))) goto 3
         if (abs(ebr) .gt. tol1) then
            rbr = (xbr - wbr)*(fx - fv)
            qbr = (xbr - vbr)*(fx - fw)
            pb  = (xbr - vbr)*qbr - (xbr - wbr)*rbr
            qbr = 2.d0*(qbr - rbr)
            if (qbr .gt. 0.d0) pb =  -pb
            qbr   = abs(qbr)
            etemp = ebr
            ebr   = dbr
            if (abs(pb) .ge. abs(.5d0*qbr*etemp) .or. pb .le.
     &         qbr*(abr - xbr) .or. pb .ge. qbr*(bbr - xbr)) goto 1
            dbr = pb/qbr
            ubr = xbr + dbr
            if ((ubr - abr) .lt. tol2 .or. (bbr - ubr) .lt. tol2)
     &         dbr = sign(tol1, xm-xbr)
            goto 2
         endif
1        continue
         if (xbr .ge. xm) then
            ebr = abr - xbr
         else
            ebr = bbr - xbr
         endif
         dbr = cgold*ebr
2        continue
         if (abs(dbr) .ge. tol1) then
            ubr = xbr + dbr
         else
            ubr = xbr + sign(tol1, dbr)
         endif
         fu = fbr(ubr)
         if (fu .le. fx) then
            if (ubr .ge. xbr) then
               abr = xbr
            else
               bbr = xbr
            endif
            vbr    = wbr
            fv     = fw
            wbr    = xbr
            fw     = fx
            xbr    = ubr
            fx     = fu
         else
            if (ubr .lt. xbr) then
               abr = ubr
            else
               bbr = ubr
            endif
            if (fu .le. fw .or. wbr .eq. xbr) then
               vbr  = wbr
               fv   = fw
               wbr  = ubr
               fw   = fu
            else if
     &       (fu .le. fv .or. vbr .eq. xbr .or. vbr .eq. wbr) then
               vbr  = ubr
               fv   = fu
            endif
         endif
11    continue
c
      ier     = 4
c
3     continue
      xminbr  = xbr
      brent   = fx
c
      return
      end
*
******************************************************************
*
