      subroutine rspec(frefr, fprice, fcoef1, ncomp1, 
     & fcoef2, ncomp2, fcoef3, ncomp3, ncl)
c                       Read tabulated spectra. A. Kuusk, 21.02.2002
c
      include 'acrmpar.h'
      include 'nch.h'
      include 'spec.h'
      include 'spec3.h'
c
      character*30 fname
      character*30 frefr, fprice, fcoef1, fcoef2, fcoef3
      dimension fcoef1(ncomp0), fcoef2(ncomp0), fcoef3(nclmax, ncomp0)
      dimension ncomp3(nclmax)
c
c                                  Read refraction index
      ire = 2
      fname = frefr
      open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98)
     &      wlgth, refr(jw)
         enddo
      close (ire)
c                                  Read Price' vectors
      fname = fprice
      open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98)
     &      wlgth, (phis(jw, j), j = 1, 4)
         enddo
      close (ire)
c                                  Read absorption spectra
      do jc = 1, ncomp1
         fname = fcoef1(jc)
         open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98) wlgth, acoef1(jw, jc)
         enddo
         close (ire)
      enddo
c
      do jc = 1, ncomp2
         fname = fcoef2(jc)
         open (ire, file = fname, status = 'old', err = 99)
         rewind ire
         jl = 1
         read (ire, '(/)', err = 98)
         do jw = 1, nspchnl
            jl = jw + 2
            read (ire, *, err = 98) wlgth, acoef2(jw, jc)
         enddo
         close (ire)
      enddo
c
      if (ncl .gt. 0) then
         do jcl = 1, ncl
            do jc = 1, ncomp3(jcl)
               fname = fcoef3(jcl, jc)
               open (ire, file = fname, status = 'old', err = 99)
               rewind ire
               jl = 1
               read (ire, '(/)', err = 98)
               do jw = 1, nspchnl
                  jl = jw + 2
                  read (ire, *, err = 98) wlgth, acoef3(jcl, jw, jc)
               enddo
               close (ire)
            enddo
         enddo
      endif
      return
98    write (*, '(3a, i4)') 
     &      'Error in the file ', fname, 'line ', jl
      stop 'RSPEC'
99    write (*, '(a)')  'File not found: ', fname
      stop 'RSPEC'
      end

